Index: branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/JobShopSchedulingProblem.cs
===================================================================
--- branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/JobShopSchedulingProblem.cs	(revision 6177)
+++ branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/JobShopSchedulingProblem.cs	(revision 6260)
@@ -43,4 +43,5 @@
 using HeuristicLab.Problems.Scheduling.Encodings.PriorityRulesVector;
 using HeuristicLab.Encodings.IntegerVectorEncoding;
+using HeuristicLab.Problems.Scheduling.Encodings.PermutationWithRepetition;
 
 namespace HeuristicLab.Problems.Scheduling {
@@ -53,5 +54,4 @@
     private JobShopSchedulingProblem(JobShopSchedulingProblem original, Cloner cloner)
       : base(original, cloner) {
-        operators = original.operators.Select(x => (IOperator)cloner.Clone(x)).ToList();
         this.encodingType = original.encodingType;
         AttachEventHandlers();
@@ -82,13 +82,9 @@
     #endregion
 
-
-    [Storable]
-    private List<IOperator> operators;
-
     [Storable]
     private JSSPEncodingTypes encodingType;
 
     public JobShopSchedulingProblem()
-      : base(new SchedulingEvaluator (), new JSMRandomCreator ()) {
+      : base(new JSSPEvaluationAlgorithm (), new JSMRandomCreator ()) {
         Parameters.Add(new ValueParameter<ItemList<JSSPJob>>("Jobs", "Jobdata defining the precedence relationships and the duration of the tasks in this JSSP-Instance.", new ItemList<JSSPJob>()));
         Parameters.Add(new OptionalValueParameter<Schedule>("BestKnownSolution", "The best known solution of this JSSP instance.")); 
@@ -103,7 +99,10 @@
       if (SolutionCreator.GetType().Equals(typeof(JSMRandomCreator)))
         encodingType = JSSPEncodingTypes.JSMEncoding;
-      else
-        encodingType = JSSPEncodingTypes.PRVEncoding;
-
+      else {
+        if (SolutionCreator.GetType().Equals(typeof(PRVRandomCreator)))
+          encodingType = JSSPEncodingTypes.PRVEncoding;
+        else
+          encodingType = JSSPEncodingTypes.PWREncoding;
+      }
       InitializeOperators();
     }
@@ -122,9 +121,14 @@
       if (encodingType == JSSPEncodingTypes.JSMEncoding) {
         Operators.AddRange(ApplicationManager.Manager.GetInstances<IJSMOperator>());
-        ((SchedulingEvaluator)this.EvaluatorParameter.ActualValue).InitializeOperatorGraph<JSMEncoding>(new JSMDecoder(), new MakespanEvaluator());
+        ((JSSPEvaluationAlgorithm)this.EvaluatorParameter.ActualValue).InitializeOperatorGraph<JSMEncoding>(new JSMDecoder(), new MakespanEvaluator());
       } else {
         if (encodingType == JSSPEncodingTypes.PRVEncoding) {
           Operators.AddRange(ApplicationManager.Manager.GetInstances<IPRVOperator>());
-          ((SchedulingEvaluator)this.EvaluatorParameter.ActualValue).InitializeOperatorGraph<PRVEncoding>(new PRVDecoder(), new MakespanEvaluator());
+          ((JSSPEvaluationAlgorithm)this.EvaluatorParameter.ActualValue).InitializeOperatorGraph<PRVEncoding>(new PRVDecoder(), new MakespanEvaluator());
+        } else {
+          if (encodingType == JSSPEncodingTypes.PWREncoding) {
+            Operators.AddRange(ApplicationManager.Manager.GetInstances<IPWROperator>());
+            ((JSSPEvaluationAlgorithm)this.EvaluatorParameter.ActualValue).InitializeOperatorGraph<PWREncoding>(new PWRDecoder(), new MakespanEvaluator());
+          }
         }
       }
@@ -146,4 +150,6 @@
     #region Importmethods
     private List<string> SplitString(string line) {
+      if (line == null)
+        return null;
       List<string> data = new List<string>(line.Split(' '));
       List<string> result = new List<string>();
@@ -155,4 +161,11 @@
 
       return result;
+    }
+    private int[] GetIntArray(List<string> data) {
+      int[] arr = new int [data.Count];
+      for (int i = 0; i < data.Count; i++ ) {
+        arr[i] = Int32.Parse(data[i]);
+      }
+      return arr;
     }
     public void ImportFromORLibrary(string fileName) {
@@ -179,9 +192,7 @@
             JSSPJob j = new JSSPJob(new IntValue(jobCount));
             for (int i = 0; i < data.Count; i++) {
-              JSSPTask t = new JSSPTask(new IntValue (i / 2), new IntValue(Int32.Parse(data[i])), new DoubleValue(Double.Parse(data[i + 1])), j);
+              JSSPTask t = new JSSPTask(new IntValue (i / 2), new IntValue(Int32.Parse(data[i])), new DoubleValue(Double.Parse(data[i + 1])), new IntValue (jobCount));
               if (j.Tasks.Count > 0) {
-                t.PreviousTask = j.Tasks[j.Tasks.Count - 1];
-                j.Tasks[j.Tasks.Count - 1].NextTask = t;
-                t.StartTime = new DoubleValue (t.PreviousTask.EndTime.Value + 2);
+                t.StartTime = new DoubleValue (j.Tasks[j.Tasks.Count - 1].EndTime.Value + 2);
               }
               j.Tasks.Add(t);
@@ -198,4 +209,37 @@
       problemFile.Close();
     }
+
+    public void ImportJSMSolution(string fileName) {
+      if (!File.Exists(fileName))
+        return;
+      StreamReader solutionFile = new StreamReader(fileName);
+      //assures that the parser only reads the first solution instance given in the file
+      bool solutionFound = false;
+      JSMEncoding solution = new JSMEncoding();
+      while (!solutionFile.EndOfStream && !solutionFound) {
+        
+        string line = solutionFile.ReadLine();
+        List<string> data = SplitString(line);
+        if (data.Count > 0 && ((int)data[0][0] >= 48 && (int)data[0][0] <= 57)) {
+          if (data.Count > 2)
+            BestKnownQualityParameter.ActualValue = new DoubleValue(Double.Parse(data[2]));
+          line = solutionFile.ReadLine();
+          data = SplitString(line);
+          while (data != null && data.Count > 0 && ((int)data[0][0] >= 48 && (int)data[0][0] <= 57)) {
+            Permutation p = new Permutation(PermutationTypes.Absolute, GetIntArray (data));
+            solution.JobSequenceMatrix.Add(p);
+
+            line = solutionFile.ReadLine();
+            data = SplitString(line);
+          }//while
+          solutionFound = true;
+        }//if
+      }//while
+      solutionFile.Close();
+
+      JSMDecoder decoder = new JSMDecoder();
+      Schedule result = decoder.CreateScheduleFromEncoding(solution, Jobs);
+      BestKnownSolution = result;
+    }
     #endregion
 
Index: branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Resource.cs
===================================================================
--- branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Resource.cs	(revision 6177)
+++ branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Resource.cs	(revision 6260)
@@ -45,8 +45,10 @@
     public DoubleValue TotalDuration {
       get {
-        if (Tasks.Count > 0)
-          return new DoubleValue(Tasks[Tasks.Count - 1].EndTime.Value);
-        else
-          return new DoubleValue (0);
+        double result = 0;
+        foreach (JSSPTask t in Tasks) {
+          if (t.EndTime.Value > result)
+            result = t.EndTime.Value;
+        }
+        return new DoubleValue (result);
       }
     }
Index: branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Schedule.cs
===================================================================
--- branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Schedule.cs	(revision 6177)
+++ branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Schedule.cs	(revision 6260)
@@ -48,10 +48,39 @@
 
     [Storable]
-    public ItemList<Resource> Resources;
+    private ItemList<Resource> resources;
+    public ItemList<Resource> Resources {
+      get { return resources; }
+      set {
+        if (resources != null) DeregisterResourcesEvents();
+        resources = value;
+        if (resources != null) RegisterResourcesEvents();
+        OnResourcesChanged();
+      }
+    }
 
     [Storable]
+    private DoubleValue quality;
     public DoubleValue Quality {
-      get;
-      set;
+      get { return quality; }
+      set {
+        if (quality != value) {
+          if (quality != null) DeregisterQualityEvents();
+          quality = value;
+          if (quality != null) RegisterQualityEvents();
+          OnQualityChanged();
+        }
+      }
+    }
+
+    public double Makespan {
+      get {
+        double quality = 0;
+        foreach (Resource r in Resources) {
+          if (r.TotalDuration.Value > quality) {
+            quality = r.TotalDuration.Value;
+          }
+        }
+        return quality;
+      }
     }
 
@@ -62,4 +91,65 @@
         Resources.Add(new Resource(new IntValue (i)));
       }
+    }
+
+    #region Events
+    public event EventHandler QualityChanged;
+    private void OnQualityChanged() {
+      var changed = QualityChanged;
+      if (changed != null)
+        changed(this, EventArgs.Empty);
+    }
+    private void RegisterQualityEvents() {
+      Quality.ValueChanged += new EventHandler(Quality_ValueChanged);
+    }
+    private void DeregisterQualityEvents() {
+      Quality.ValueChanged -= new EventHandler(Quality_ValueChanged);
+    }
+    private void Quality_ValueChanged(object sender, EventArgs e) {
+      OnQualityChanged();
+    }
+
+    public event EventHandler ResourcesChanged;
+    private void OnResourcesChanged() {
+      var changed = ResourcesChanged;
+      if (changed != null)
+        changed(this, EventArgs.Empty);
+    }
+    private void RegisterResourcesEvents() {
+      Resources.PropertyChanged += new System.ComponentModel.PropertyChangedEventHandler(Resources_PropertyChanged);
+    }
+    private void DeregisterResourcesEvents() {
+      Resources.PropertyChanged -= new System.ComponentModel.PropertyChangedEventHandler(Resources_PropertyChanged);
+    }
+    private void Resources_PropertyChanged(object sender, EventArgs e) {
+      OnResourcesChanged();
+    }
+    #endregion
+
+    public void AddTask(JSSPTask task, JSSPJob job) {
+      task.StartTime = new DoubleValue (ComputeEarliestStartTime(task, job));
+      Resource affectedResource = resources[task.ResourceNr.Value];
+      int i = 0;
+      while (i < affectedResource.Tasks.Count && affectedResource.Tasks[i].StartTime.Value < task.StartTime.Value)
+        i++;
+
+      if (i >= affectedResource.Tasks.Count)
+        affectedResource.Tasks.Add(task);
+      else
+        affectedResource.Tasks.Insert(i, task);
+    }
+    public double ComputeEarliestStartTime(JSSPTask t, JSSPJob job) {
+      Resource affectedResource = resources[t.ResourceNr.Value];
+      double lastMachineEndTime = affectedResource.TotalDuration.Value;
+      double previousJobTaskEndTime = 0;
+      JSSPTask previousTask = job.GetPreviousTask(t);
+      if (previousTask != null)
+        previousJobTaskEndTime = previousTask.EndTime.Value;
+
+      return Math.Max(previousJobTaskEndTime, lastMachineEndTime);
+    }
+    public double ComputeEarliestCompletionTime(JSSPTask t, JSSPJob job) {
+      Resource affectedResource = resources[t.ResourceNr.Value];
+      return ComputeEarliestStartTime(t, job) + t.Duration.Value;
     }
 
